-- MoonTimeMain.lua

-- Variablen
local NameOfProject = "MoonTime"										-- Name des Projekts
local EventFrame														-- Frame, das auf Events reagiert
local TimeSinceLastUpdate = 0.0
local UpdateFrequency = 1/100;
local Layout
local MoonTimeObject													-- dummy fuer die Objects
local MoonTimeMainframe 												-- dummy fuer das Hauptframe
local _, playerclass = UnitClass("player");

MoonTime = {}
MoonTimeDoorKeeper = CreateFrame( "Frame", "MTDoorKeeper", UIParent )















local ConfigLayoutList

local L
if ( GetLocale() == "deDE" ) then
	L = MoonTime_Strings["deDE"]
	else
	L = MoonTime_Strings["enGB"]
end



MoonTime_DB = {															-- default Konfiguration,
	-- wird whrend des Variabelnladens
	-- ueberschrieben
	
};


MoonTime_Layout_Liste = {}										-- enthaelt moegliche Layouts

local debugging = false

local MoonTimeMain_ready = false;
local Configmode = false;
local DoorKeeperLayoutList = {}
local DoorKeeperConfigList = {}
local currentlayoutframe = {}




function MoonTime.debug ( self, msg )							-- Beginn debug
	if debugging then 													-- falls debugging aktiv ist
		DEFAULT_CHAT_FRAME:AddMessage("|cff00FFFF"..NameOfProject.."(debug):|r "..msg)		
		-- Einfache Routine zur Ausgabe von Informationen
	end
end																		-- Ende debug

function MoonTime.echo( self, msg )												-- Beginn echo
	-- Einfache Routine zur Ausgabe von Nachrichten
	if not msg then
		msg = "Error: nil"
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00FFFF"..NameOfProject..":|r "..msg)
	
end	

-- Ende echo



function MoonTime.help( self )															-- Beginn help
	InterfaceOptionsFrame_OpenToCategory("MoonTime")
	InterfaceOptionsFrame:Hide()
	InterfaceOptionsFrame_OpenToCategory("MoonTime")
end			

function MoonTime.list( self )										-- lists the layouts
	MoonTime:echo ("Available layouts:")
	for index, value in pairs(MoonTime_Layout_Liste) do
		MoonTime:echo(index)
	end	
end	



function MoonTime.canuse( self)
	local moonkin = UnitBuff("player", GetSpellInfo(24858)) 
	
	-- UnitIsCorpse("target") 
	if not UnitHasVehicleUI("player") and moonkin and UnitCanAttack("player","target") and not UnitIsDead("target") then
		return true
		else
		return false
	end
end



function MoonTime.registerMoonTimeLayout( self, frame )
	-- Die Moeglichkeit fr Layouts, sich einzutragen
	local _, playerclass = UnitClass("player");
	if playerclass == "DRUID" and frame.ID then
		MoonTime_Layout_Liste[frame.ID] = frame;
		frame.Mainframe = MoonTimeMainframe
		frame.Objectframe = MoonTimeObject
		MoonTime:debug("Layout \""..frame.ID.."\" has been registered.")
		MoonTime:CreateMoonTimeLayoutNow(frame.ID);
		
	end
end

function MoonTime.setLayout( self, layoutName )
	local oldLayout = MoonTime_DB["layout"]								-- altes Layout wird behalten wegen Loeschen
	if MoonTime_Layout_Liste[layoutName] then							-- falls es das Layout gibt
		MoonTime_DB["layout"] = layoutName
		
		currentlayoutframe = MoonTime_Layout_Liste[MoonTime_DB["layout"]]
		MoonTimeMainframe:SetScript("OnUpdate", nil);					-- Update wird unterbunden waehrend des Wechsels
		if MoonTime_Layout_Liste[oldLayout] then						-- altes Layout loeschen, falls existent
			MoonTime_Layout_Liste[oldLayout]:deleteLayout()
		end
		MoonTime:CreateMoonTimeLayout(MoonTime_DB["layout"])						-- neues Layout erstellen
		
		if MoonTime:canuse() then
			currentlayoutframe:Show()
			-- MoonTime_Layout_Liste[MoonTime_DB["layout"]]:Show()
			MoonTimeMainframe:Show();
		end
		
		
		MoonTime:debug( "Layout \"" .. layoutName .. "\" is set");
		else
		MoonTime:debug( "Layout \"" .. layoutName .. "\" is not known. Type |cffFFFF00/moontime list|r to get all available layouts");
	end
end




function MoonTime.CreateMoonTimeLayoutNow( self, name )
	if ( name == MoonTime_DB["layout"] ) then
		MoonTime:CreateMoonTimeLayout(MoonTime_DB["layout"])								-- Layout wird erstellt
	end
end

function MoonTime.OnEvent( self, event, name, ...)										-- Beginn OnEvent
	if event=="VARIABLES_LOADED" then									-- falls das ausloesende Event VARIABLES_LOADED ist ...
		-- werden die ausstehenden Events registriert
		
		
		
		
		-- EventFrame:UnregisterAllEvents();
		
		MoonTimeMainframe = MoonTime:CreateMainFrame()								-- Das Hauptfenster wird erzeugt
		MoonTimeMainframe:Show()
		
		
		MoonTime:UpdateDB()
		MoonTimeObject = MoonTimeLayoutObj()
		
		ConfigLayoutList = MoonTimeBuildConfig()
		ConfigLayoutList.mainFrame = MoonTimeMainframe;
		
		
		
		-- MoonTimeMainframe wird positioniert
		MoonTimeMainframe:SetPoint(MoonTime_DB["position"]["point"], nil, MoonTime_DB["position"]["relativePoint"], MoonTime_DB["position"]["offsetX"], MoonTime_DB["position"]["offsetY"])
		
		-- MoonTimeMainframe:Hide();
		MoonTimeMain_ready = true;
		MoonTime:LetAllIn()
		
		
		
		
		MoonTimeMainframe:Show();
		
		
		
		
	end
	-- if event=="LOADING_SCREEN_DISABLED" then
		
		-- local t=GetTime()
		
		-- local blubb = CreateFrame( "Frame", "blubb", UIParent )
		-- blubb:SetScript("OnUpdate", function()
			-- if GetTime()-t > 3 then
				-- blubb:SetScript("OnUpdate", nil)
				-- InterfaceOptionsFrame_OpenToCategory("MoonTime")
				-- InterfaceOptionsFrame:Hide()
				-- InterfaceOptionsFrame_OpenToCategory("noBrainPlus")
				
			-- end
		-- end)
		
		
	-- end
	
	
end																		-- Ende OnEvent

function MoonTime.ToggleConfig()
	if Configmode then
		Configmode = false;
		else
		Configmode = true;
		currentlayoutframe:Hide()
		-- MoonTime_Layout_Liste[MoonTime_DB["layout"]]:Hide()
		MoonTimeMainframe:Hide();
		end
		
	end
	
	function MoonTime.UpdateDB ()
		defaultDB = {
		["position"] = {	
			["point"] = "CENTER",
			["relativeTo"] = UIParent,
			["relativePoint"] = "CENTER",
			["offsetX"] = 0,
			["offsetY"] = 0,
		},
		["layout"] = "noBrain",
		["enabled"] = true,
	};
	
	if MoonTime_DB then
		for value in pairs(defaultDB) do
			if MoonTime_DB[value] == nil then
				print(MoonTime_DB)
				MoonTime_DB[value] = defaultDB[value]
			end
		end
	end
	
	-- defaultDB = {};
	defaultDB = {
		["boxtextposi"] = 0,
		["blink_factor"] = 8,
		["blink_time_descale"] = 0.15,
		["blinkspells"] = {
			[SS_icon] = true,
			[MF_icon] = true,
			[SunF_icon] = true,
			[W_icon] = false,
			[SF_icon] = false,
		},
		["rotation"] = "default",
		["default"] = "if spell == SF_name then\n  LunarEmpowered = LunarEmpowered -1\nend\nif spell == W_name then\n  SolarEmpowered = SolarEmpowered -1\nend\n\nif CA_duration > 0 then\n  if SunF_CD < 24*.3 then\n    return MF_icon\n  end\n\n  if CA_duration < casttime+SF_castTime and SunF_CD < 20 then\n    return MF_icon\n  end\n\n  if isSolar(0) then\n    if SolarEmpowered < 1 and charges > 0 and spell~=SS_name then\n      return SS_icon\n    end\n\n    return W_icon\n  end\n\n  if LunarEmpowered < 1 and charges > 0 and spell~=SS_name then\n    return SS_icon\n  end\n\n  return SF_icon\n\nend\n\n\nif charges>0 and spell~=SS_name then\n  if LunarEmpowered < 1 and futurePower <-50 and EDir==\"moon\" then\n    return SS_icon\n  end\n  if SolarEmpowered < 1 and futurePower > 50 and EDir==\"sun\" then\n    return SS_icon\n  end\nend\n\nif charges>2 and chargetime < 5 and spell~=SS_name then\n  return SS_icon\nend\n\n\nif isSolar(casttime) and SunF_CD < 1 then\n  return SunF_icon\nend\n\nif isLunar(casttime) and MF_CD < 1 then\n  return MF_icon\nend\n\n\nif GetSetTalentInRow(7) == 1 then\n  if solarpeak and SunF_CD< 20 then\n    return SunF_icon\n  end\n\n  if lunarpeak and MF_CD< 20 then\n    return MF_icon\n  end\nelse\n  if isSolar(casttime) and isLunar(casttime + SF_castTime) then\n    return SunF_icon\n  end\n\n  if lunarpeak and MF_CD< 40 then\n    return MF_icon\n  end\nend\n\n\n\nif dpet_SF > dpet_W then\n  return SF_icon\nelse\n  return W_icon\nend",
		["mix"] = "if spell == SF_name then\n  LunarEmpowered = LunarEmpowered -1\nend\nif spell == W_name then\n  SolarEmpowered = SolarEmpowered -1\nend\n\nif CA_duration > 0 then\n  if SunF_CD < 24*.3 then\n    return MF_icon\n  end\n\n  if CA_duration < casttime+SF_castTime and SunF_CD < 20 then\n    return MF_icon\n  end\n\n  if isSolar(0) then\n    if SolarEmpowered < 1 and charges > 0 and spell~=SS_name then\n      return SS_icon\n    end\n\n    return W_icon\n  end\n\n  if LunarEmpowered < 1 and charges > 0 and spell~=SS_name then\n    return SS_icon\n  end\n\n  return SF_icon\n\nend\n\n\nif charges>1 and spell~=SS_name then\n  if LunarEmpowered < 1 and futurePower <-50 and futurePower >-100 and EDir==\"moon\" then\n    return SS_icon\n  end\n  if SolarEmpowered < 1 and futurePower > 50 and futurePower < 100 and EDir==\"sun\" then\n    return SS_icon\n  end\nend\n\nif charges>2 and chargetime < 5 and spell~=SS_name then\n  return SS_icon\nend\n\n\nif isSolar(casttime) and SunF_CD < 1 then\n  return SunF_icon\nend\n\nif isLunar(casttime) and MF_CD < 1 then\n  return MF_icon\nend\n\n\nif GetSetTalentInRow(7) == 1 then\n  if solarpeak and SunF_CD< 20 then\n    return SunF_icon\n  end\n\n  if lunarpeak and MF_CD< 20 then\n    return MF_icon\n  end\n\nelse\n\n  if isSolar(casttime) and isLunar(casttime + SF_castTime) and SunF_CD<20 then\n    return SunF_icon\n  end\n\n  if lunarpeak and MF_CD < 40 then\n    return MF_icon\n  end\nend\n\n\n\nif dpet_SF > dpet_W then\n  return SF_icon\nelse\n  return W_icon\nend",
		["ae"] = "if spell == SF_name then\n  LunarEmpowered = LunarEmpowered -1\nend\nif spell == W_name then\n  SolarEmpowered = SolarEmpowered -1\nend\n\nif SR_duration <= casttime and charges>0 then\n  return SR_icon\nend\n\nif CA_duration > 0 then\n  if SunF_CD < 24*.3 then\n    return MF_icon\n  end\n\n  if CA_duration < casttime+SF_castTime and SunF_CD < 20 then\n    return MF_icon\n  end\n\n  if isSolar(0) then\n    if SolarEmpowered < 1 and charges > 0 and spell~=SS_name then\n      return SS_icon\n    end\n\n    return W_icon\n  end\n\n  if LunarEmpowered < 1 and charges > 0 and spell~=SS_name then\n    return SS_icon\n  end\n\n  return SF_icon\n\nend\n\n\nif charges>1 and chargetime < 5 and spell~=SS_name then\n  return SS_icon\nend\n\n\nif isSolar(casttime) and SunF_CD < 1 then\n  return SunF_icon\nend\n\nif isLunar(casttime) and MF_CD < 1 then\n  return MF_icon\nend\n\n\nif GetSetTalentInRow(7) == 1 then\n  if solarpeak and SunF_CD< 20 then\n    return SunF_icon\n  end\n\n  if lunarpeak and MF_CD< 20 then\n    return MF_icon\n  end\nelse\n  if isSolar(casttime) and isLunar(casttime + SF_castTime) then\n    return SunF_icon\n  end\n\n  if lunarpeak and MF_CD< 40 then\n    return MF_icon\n  end\nend\n\n\n\nif dpet_SF > dpet_W then\n  return SF_icon\nelse\n  return W_icon\nend",
		["custom1"]  = "return FF_icon",
		["custom2"]  = "return FF_icon",
		["default_posi"] = 0,
		["custom1_posi"] = 0,
		["custom2_posi"] = 0,
	}
	
	if not MoonTime_DB["Layout_noBrain"] then
		MoonTime_DB["Layout_noBrain"] = {}
	end
	
	
	-- if 	MoonTime_DB["Layout_noBrain"]["default"] ~= defaultDB["default"] then
	-- MoonTime_DB["Layout_noBrain"]["custom1"] = nil
	-- MoonTime_DB["Layout_noBrain"]["custom2"] = nil
	-- end
	
	MoonTime_DB["Layout_noBrain"]["default"] = nil
	MoonTime_DB["Layout_noBrain"]["mix"] = nil
	MoonTime_DB["Layout_noBrain"]["ae"] = nil
	
	if MoonTime_DB["Layout_noBrain"]["custom1"] == nil and MoonTime_DB["Layout_noBrain"]["boxtext"] ~= nil then
		MoonTime_DB["Layout_noBrain"]["custom1"] = MoonTime_DB["Layout_noBrain"]["boxtext"]
	end
	
	for value in pairs(defaultDB) do
		if MoonTime_DB["Layout_noBrain"][value] == nil then
			MoonTime_DB["Layout_noBrain"][value] = defaultDB[value]
		end
	end
end






function MoonTime.enable()														-- Beginn enable
end																		-- Ende enable

function MoonTime.disable()														-- Beginn enable
end																		-- Ende enable

function MoonTime.move( self )															-- Beginn config
	MoonTimeMainframe:SetBackdropColor(1,0,0,1)
	MoonTimeMainframe:SetMovable(true)
	MoonTimeMainframe:EnableMouse(true)
	MoonTimeMainframe.isLocked = false
	MoonTimeMainframe:Show()
end																		-- Ende config

function MoonTime.setPosition( self )															-- Beginn config
	MoonTimeMainframe:SetMovable(false)
	MoonTimeMainframe:EnableMouse(false)
	MoonTimeMainframe.isLocked = true
	
	MoonTimeMainframe:ClearAllPoints()
	MoonTimeMainframe:SetPoint(MoonTime_DB["position"]["point"], UIPARRENT, MoonTime_DB["position"]["relativePoint"], MoonTime_DB["position"]["offsetX"], MoonTime_DB["position"]["offsetY"])
end	


function MoonTime.toggle(self, msg)													-- Beginn toggle
	origMsg = msg
	msg = strtrim( msg )												-- entferne ueberfluessige whitespaces
	msg = msg:lower()													-- in Kleinbuchstaben verwandeln
	
	if ( msg:find(",") ) then
		local translate = {
			["default"] = "0",
			["custom1"] = "1",
			["custom2"] = "2",
			["mix"] = "3", 
			["ae"] = "4"
		}
		
		local test = msg:gsub(" ", ""):gsub("ae", "4"):gsub("mix", "3")
		
		local t = test:find(",")
		local a = test:sub(1,t-1)
		local b = test:sub(t+1,test:len())
		
		if a == "0" or a == "1" or a == "2" or a == "3" or a == "4" then
			if b == "0" or b == "1" or b == "2" or b == "3" or b == "4" then
				
				if a ~= translate[MoonTime_DB["Layout_noBrain"]["rotation"]] then
					msg = a
					else
					msg = b
				end
				
			end
		end
		
		
		
	end
	
	if( msg == "help" ) then MoonTime:help()										-- rufe help auf
		elseif( msg == "move" ) then MoonTime:move()									-- rufe move auf
		-- rufe enable auf
		elseif ( msg == "reset" ) then 
		
		MoonTime_DB = nil
		ReloadUI()
		
		elseif ( msg == "0" ) then
		
		MoonTime_DB["Layout_noBrain"]["rotation"] = "default"
		MoonTime:setLayout(MoonTime_DB["layout"])
		MoonTime:echo(L["rotation_0_set"])
		
		elseif ( msg == "1" ) then
		
		MoonTime_DB["Layout_noBrain"]["rotation"] = "custom1"
		MoonTime:setLayout(MoonTime_DB["layout"])
		MoonTime:echo(L["rotation_1_set"])
		
		elseif ( msg == "2" ) then
		
		MoonTime_DB["Layout_noBrain"]["rotation"] = "custom2"
		MoonTime:setLayout(MoonTime_DB["layout"])
		MoonTime:echo(L["rotation_2_set"])
		
		elseif ( msg == "3" ) or ( msg == "mix" ) then
		
		MoonTime_DB["Layout_noBrain"]["rotation"] = "mix"
		MoonTime:setLayout(MoonTime_DB["layout"])
		MoonTime:echo(L["rotation_3_set"])
		
		elseif ( msg == "4" ) or ( msg == "ae" ) then
		
		MoonTime_DB["Layout_noBrain"]["rotation"] = "ae"
		MoonTime:setLayout(MoonTime_DB["layout"])
		MoonTime:echo(L["rotation_4_set"])
		
		else
		MoonTime:help()
	end
end																		-- Ende toggle

function MoonTime.OnUpdate(self, elapsed)										-- Beginn OnUpdate
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed; 	
	
	while (TimeSinceLastUpdate > UpdateFrequency) do
		-- wie bei create wird dies umgeschrieben, dass die jeweils zutreffende Function angesprochen wird
		--MoonTime_Layout_Liste[MoonTime_DB["layout"]]:Update()
		--echo (MoonTime_Layout_Liste[MoonTime_DB["layout"]].ID)
		-- print("OnUpdate")
		if MoonTime:canuse() then
			currentlayoutframe:Update()
			currentlayoutframe:Show()
			
			if IsSpellInRange(SF_name, "target")>0 then
				MoonTimeMainframe:SetAlpha(1)
				else
				MoonTimeMainframe:SetAlpha(MoonTime_DB["alpha"]/100)
			end
			
			-- MoonTime_Layout_Liste[MoonTime_DB["layout"]]:Update()
			-- MoonTime_Layout_Liste[MoonTime_DB["layout"]]:Show()
			else
			currentlayoutframe:Hide()
			-- MoonTime_Layout_Liste[MoonTime_DB["layout"]]:Hide()
		end
		
		TimeSinceLastUpdate = TimeSinceLastUpdate - UpdateFrequency;
	end
	
end																		-- Ende OnUpdate
function MoonTime.CreateMainFrame ( self )					
	
	local frame = CreateFrame( "Frame", "MTMainframe", UIParent )
	
	local oldHide = frame.Hide
	frame.Hide = function(...)
		return oldHide(...)
	end
	
	
	
	-- local oldShow = frame.Show
	-- frame.Show = function(...)
	-- return oldShow(...)
	-- end
	
	
	frame:SetMovable(false)
	frame:EnableMouse(false)
	frame:SetClampedToScreen(true)
	frame:SetBackdrop({
		bgFile = "",
		tile = true, tileSize = height, edgeSize = 10,
		insets = { left = 2, right = 2, top = 2, bottom = 2 }
	})
	
	frame.isLocked = true
	frame:SetScript("OnMouseDown", 
		function(self, button)
			if ( ( ( not self.isLocked ) or ( self.isLocked == 0 ) ) and ( button == "LeftButton" ) ) then
				self:StartMoving();
				self.isMoving = true;
			end
		end
	)
	frame:SetScript("OnMouseUp", 
		function(self)
			if ( self.isMoving ) then
				self:StopMovingOrSizing();
				self.isMoving = false;
				
				-- falls die Position gespeichert werden soll
				p,_,pt,x,y = MoonTimeMainframe:GetPoint();																			
				local c = 0;
				local d = 0;
				local a = 0;
				local b = 0;
				
				if ( string.find(p, "LEFT") ) then
					a=1;
					elseif ( string.find(p, "RIGHT") ) then
					a=-1;
				end
				
				if ( string.find(p, "TOP") ) then
					b=-1;
					elseif ( string.find(p, "BOTTOM") ) then
					b=1;
				end
				
				while not ( p == "CENTER" or p == "TOP" or p == "BOTTOM" ) do
					MoonTimeMainframe:SetPoint(p, UIPARRENT, pt, x+a, y)
					self:StartMoving();
					self:StopMovingOrSizing();
					c = c+1;
					
					p,_,pt,x,y = MoonTimeMainframe:GetPoint();	
				end
				
				while not ( p == "CENTER" or p == "LEFT" or p == "RIGHT" ) do
					MoonTimeMainframe:SetPoint(p, UIPARRENT, pt, x, y+b)
					self:StartMoving();
					self:StopMovingOrSizing();
					d = d+1;
					
					p,_,pt,x,y = MoonTimeMainframe:GetPoint();	
				end
				
				MoonTimeMainframe:ClearAllPoints()
				MoonTimeMainframe:SetPoint("CENTER", UIPARRENT, "CENTER", x-a*c, y-b*d)
				
				MoonTime_DB["position"]["point"], _, MoonTime_DB["position"]["relativePoint"], MoonTime_DB["position"]["offsetX"], MoonTime_DB["position"]["offsetY"] = frame:GetPoint(1)															
				
				
				self:SetMovable(false)
				self:EnableMouse(false)
				self.isLocked = true
				self:SetBackdropColor(1,0,0,0)
			end
			MoonTime_DB["position"]["offsetX"]= floor(MoonTime_DB["position"]["offsetX"])
			MoonTime_DB["position"]["offsetY"]= floor(MoonTime_DB["position"]["offsetY"])
			InterfaceOptionsFrame_OpenToCategory("MoonTime")
		end
	)
	
	frame:SetHeight(100)
	frame:SetWidth(100)
	frame:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background"})
	frame:SetBackdropColor(1,0,0,0)
	frame:EnableMouse(false)
	frame:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	frame:Show()
	
	return frame
	
end

function MoonTime.CreateMoonTimeLayout( self, which )											-- Beginn CreateFrame
	if MoonTime_Layout_Liste[which] then 
		MoonTime_Layout_Liste[which]:createLayout(MoonTimeMainframe);
		currentlayoutframe = MoonTime_Layout_Liste[which]
		MoonTime:debug("Layout \""..which.."\" loaded.")
	end
	
	MoonTimeMainframe:SetScript("OnUpdate", function(self, event, ... ) MoonTime:OnUpdate(event, ...) end)					-- Seine UpdateRoutine wird angeworfen
	-- Da die Updateroutine nur dann angeworfen wird, wenn das Fenster
	-- sichtbar ist, wird OnUpdate auch nur dann aufgerufen, wenn es gebraucht
	-- wird
	
end																		-- Ende CreateFrame


function MoonTime.initialize(self)													-- Beginn initialize
	
	SlashCmdList["MOONTIME"] = function( msg ) MoonTime:toggle( msg ) end
	SLASH_MOONTIME1 = "/moontime";
	SLASH_MOONTIME2 = "/moon";
	
	EventFrame = CreateFrame( "Frame", "MTEventframe", UIParent	)
	EventFrame:SetScript("OnEvent", function(self, event, ... ) MoonTime:OnEvent(event, ...) end)
	EventFrame:RegisterEvent("VARIABLES_LOADED");
	EventFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
	EventFrame:RegisterEvent("LOADING_SCREEN_DISABLED")
	
	
	--MoonTimeObject = MoonTimeLayoutObj()
	
	MoonTime:echo("initialized...")
	
end	

-- Ende initialize

function MoonTime.LetAllIn(self)
	for number, frame in pairs(DoorKeeperLayoutList) do
		MoonTime:registerMoonTimeLayout(frame)
	end
	for number, frame in pairs(DoorKeeperConfigList) do
		frame.createConfig(ConfigLayoutList)
	end
end


MoonTimeDoorKeeper.RegisterLayout = function(self, frame, ... ) 
	if playerclass == "DRUID" then 
		if not MoonTimeMain_ready then
			tinsert(DoorKeeperLayoutList, frame)
			else
			MoonTime:registerMoonTimeLayout(frame, ...) 
		end
	end 
end


MoonTimeDoorKeeper.RegisterConfig = function(self, frame, ...) 
	if playerclass == "DRUID" then 
		if not MoonTimeMain_ready then
			tinsert(DoorKeeperConfigList, frame)
			else
			frame.createConfig(ConfigLayoutList) 
		end
	end 
end



-- MoonTimeDoorKeeper:SetScript("OnUpdate", function(self) if MoonTimeMain_ready then MoonTimeDoorKeeper:SetScript("OnUpdate", nil) MoonTime:LetAllIn()  end end);



-- Hilfsfunktionen zum Erstellen von Frames

function MoonTime.CreateFrame(self, frameType, name, parent, template, point, relativeTo, relativePoint, xOffset, yOffset, width, height)
	local frame = CreateFrame(frameType, name, parent, template);
	frame:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset);
	frame:SetWidth(width);
	frame:SetHeight(height);
	
	return frame
end

function MoonTime.CreateFontString(self, frame, name, layer, template, point, relativeTo, relativePoint, xOffset, yOffset, width, height, justifyH, justifyV, textColorR, textColorG, textColorB, textColorA)
	local fontstring = frame:CreateFontString(nil, layer, template)
	fontstring:SetPoint(point, relativeTo, relativePoint, xOffset, yOffset)
	fontstring:SetWidth(width)
	fontstring:SetHeight(height)
	fontstring:SetJustifyH(justifyH)
	fontstring:SetJustifyV(justifyV)
	fontstring:SetTextColor( textColorR, textColorG, textColorB, textColorA );
	
	return fontstring
end





function round(number, decimals)
	return tonumber((("%%.%df"):format(decimals)):format(number))
end

function MoonTime.ShakeIt()
	if ((GetTime()*100)%10)<5 and GetTime()%1.5>.5 then
		return math.random(5)-3
	end
	return 0
end



if playerclass == "DRUID" and UnitLevel("player")>=85 then
	MoonTime:initialize()															-- make it so!
end



