-- noBrainConfig.lua

local function noBrainBuildConfig(MoonTimeConfigPanel)
	local L
	
	if ( GetLocale() == "deDE" ) then
		L = MoonTime_noBrainConfig_Strings["deDE"]
		else
		L = MoonTime_noBrainConfig_Strings["enGB"]
	end
	
	
	local MoonTime_Layout_noBrain_ConfigPanel = CreateFrame( "ScrollFrame", "MoonTime_Layout_noBrain_ConfigPanel", MoonTimeConfigPanel);
	MoonTime_Layout_noBrain_ConfigPanel:SetBackdropColor(1,0,1,1)
	MoonTime_Layout_noBrain_ConfigPanel:SetWidth(200)
	MoonTime_Layout_noBrain_ConfigPanel:SetHeight(200)
	MoonTime_Layout_noBrain_ConfigPanel.name = "noBrain Rotation Editor";
	MoonTime_Layout_noBrain_ConfigPanel.parent = MoonTimeConfigPanel.name;
	
	local MoonTime_Layout_noBrain_ScrollPanel = CreateFrame( "Frame", "MyAddonScrollChild", MoonTimeConfigPanel);
	MoonTime_Layout_noBrain_ScrollPanel:SetHeight(500)
	MoonTime_Layout_noBrain_ScrollPanel:SetWidth(100)
	MoonTime_Layout_noBrain_ConfigPanel:SetScrollChild(MoonTime_Layout_noBrain_ScrollPanel)
	
	-- InterfaceOptions_AddCategory(MoonTime_Layout_noBrain_ConfigPanel);
	
	
	
	local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrain_ConfigPanel, "textbox", "ARTWORK", "GameFontNormalLarge", "TOPLEFT", MoonTime_Layout_noBrain_ConfigPanel, "TOPLEFT", 10, -10, 200, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox:SetText("|cffFFFF00".."Rotation Editor (alpha)".."|r")
	textbox:Show()	
	local textbox = MoonTime:CreateFontString(MoonTime_Layout_noBrain_ConfigPanel, "textbox", "ARTWORK", "GameFontNormal", "TOPLEFT", textbox, "BOTTOMLEFT", 0, 0, 500, 100, "LEFT", "CENTER",  1, 1, 1, 1 );
	textbox:SetText(L["editordescription"])
	textbox:SetHeight(textbox:GetStringHeight())
	textbox:Show()	
	
	
	
	
	
	
	
	function CreateEditBox(self, name, parent, width, height)
		
		local scrollframe = MoonTime:CreateFrame("ScrollFrame", "ScrollFrame_"..name, parent, "UIPanelScrollFrameTemplate", "TOPLEFT", parent, "TOPLEFT", 0, 0, width, height)
		scrollframe.name = "Scrollframe";
		
		local scrollchild = CreateFrame("EditBox", "LBPEditBox_"..name, scrollframe) --, "InputBoxTemplate")
		scrollchild:SetPoint("TOPLEFT", scrollframe, "TOPLEFT", 8,-6)
		scrollchild:SetPoint("BOTTOMRIGHT", scrollframe, "BOTTOMRIGHT", -8,6)
		scrollchild:SetScript("OnEscapePressed", function(self) EditBox_ClearFocus(self) end)
		scrollchild:SetScript("OnEditFocusLost", function(self) EditBox_ClearHighlight(self); end)
		scrollchild:SetScript("OnEditFocusGained", function(self) EditBox_HighlightText(self); end)
		scrollchild:SetFont("Fonts\\ARIALN.TTF",14,"none")
		scrollchild:SetMultiLine(true)
		scrollchild:SetAutoFocus(false) 
		--scrollchild:SetMaxLetters(255);
		scrollchild:SetCursorPosition(0)
		scrollchild:SetScript("OnCursorChanged", 
			function(self, x, y, w, h) 
				local d = -y-scrollframe:GetVerticalScroll()
				if d>floor(height/13.99)*13.99 or d<0 then 
					
					scrollframe:SetVerticalScroll(math.max(scrollframe:GetVerticalScroll()+13.99*d/abs(d),0)) 
					scrollframe:UpdateScrollChildRect()
				end 
			end
		)
		
		scrollframe:SetSize(width, height)--80-8-8)
		scrollchild:SetSize(width, height)
		scrollframe:SetScrollChild(scrollchild)
		
		--scrollframe:Hide()
		
		return scrollframe, scrollchild
	end
	
	
	
	
	
	
	
	
	
	-- local button1 = MoonTime:CreateFrame("BUTTON", "MoonTimeMoveButton", MoonTime_Layout_noBrain_ConfigPanel, "UIPanelButtonTemplate", 'TOPLEFT', MoonTime_Layout_noBrain_ConfigPanel, 'TOPLEFT', 10, -180, 100, 30)
	-- button1:SetText(L["noBrainConfig_TitleDefaultRotation"])
	-- button1:SetScript("OnClick", function(self) end)
	
	-- local button2 = MoonTime:CreateFrame("BUTTON", "MoonTimeMoveButton", MoonTime_Layout_noBrain_ConfigPanel, "UIPanelButtonTemplate", 'TOPLEFT', MoonTime_Layout_noBrain_ConfigPanel, 'TOPLEFT', 110, -180, 100, 30)
	-- button2:SetText("AE")
	-- button1:SetScript("OnClick", function(self) end)
	
	
	-- local button3 = MoonTime:CreateFrame("BUTTON", "MoonTimeMoveButton", MoonTime_Layout_noBrain_ConfigPanel, "UIPanelButtonTemplate", 'TOPLEFT', MoonTime_Layout_noBrain_ConfigPanel, 'TOPLEFT', 210, -180, 100, 30)
	-- button3:SetText("Mix")
	-- button1:SetScript("OnClick", function(self) end)
	
	
	-- local button4 = MoonTime:CreateFrame("BUTTON", "MoonTimeMoveButton", MoonTime_Layout_noBrain_ConfigPanel, "UIPanelButtonTemplate", 'TOPLEFT', MoonTime_Layout_noBrain_ConfigPanel, 'TOPLEFT', 310, -180, 100, 30)
	-- button4:SetText("Custom I")
	-- button1:SetScript("OnClick", function(self) end)
	
	
	-- local button5 = MoonTime:CreateFrame("BUTTON", "MoonTimeMoveButton", MoonTime_Layout_noBrain_ConfigPanel, "UIPanelButtonTemplate", 'TOPLEFT', MoonTime_Layout_noBrain_ConfigPanel, 'TOPLEFT', 410, -180, 100, 30)
	-- button5:SetText("Custom II")
	-- button1:SetScript("OnClick", function(self) end)
	
	
	
	
	local aussen = CreateFrame("Frame","Aussenframe", MoonTime_Layout_noBrain_ConfigPanel)
	aussen:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	-- aussen:SetBackdrop({bgFile = "Interface/CHATFRAME/CHATFRAMEBACKGROUND", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	aussen:SetBackdropColor(1,1,1,1)
	aussen:SetPoint("TOPLEFT", MoonTime_Layout_noBrain_ConfigPanel, "TOPLEFT", 10, -100)
	aussen:SetSize(600,355+80)
	aussen:Show();
	
	
	local liste = {"default", "mix", "ae", "custom1", "custom2"}
	local tabs ={}
	local boxes = {}
	
	local MoonTime_Layout_noBrain_ScrollFrame, MoonTime_Layout_noBrain_editbox
	
	
	local restore
	
	local selecttab = function(rot)
		
		for k,name in pairs(liste) do
			tabs[name].labelframe:SetTextColor( 1, 1, 1, .5 )
			tabs[name].black:Hide()
			
			boxes[name]:Hide()
		end
		
		tabs[rot].labelframe:SetTextColor( 1, 1, 1, 1 )
		tabs[rot].black:Show()
		
		
		boxes[rot]:Show()
		boxes[rot].editbox:SetFocus() 
		boxes[rot].editbox:SetCursorPosition(MoonTime_DB["Layout_noBrain"]["cursor_posi_"..rot] or 0)
		-- print(MoonTime_DB["Layout_noBrain"]["cursor_posi_"..rot])
		-- boxes[rot].editbox:SetCursorPosition(0)
		
		
		restore = MoonTime_DB["Layout_noBrain"][rot]
		
	end
	
	
	
	
	
	for k,name in pairs(liste) do
		
		local tab = MoonTime:CreateFrame("Frame","Aussenframe", MoonTime_Layout_noBrain_ConfigPanel, nil, "TOPLEFT", aussen, "TOPLEFT", -100+20+k*105, 22, 100, 30)
		tab:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/Tooltips/UI-Tooltip-Border",tile = true, tileSize = 16, edgeSize = 16, insets = { left = 3, right = 3, top = 3, bottom = 3 } });
		tab:SetFrameLevel(aussen:GetFrameLevel()-1)
		
		tab.labelframe = MoonTime:CreateFontString(tab, nil,"ARTWORK","GameFontNormal","CENTER", tab, "CENTER", 0, 0, 100,30, "CENTER", "MIDDLE", 1, 1, 1, 1)
		tab.labelframe:SetText(L["noBrainConfig_Title_"..name])
		
		tab.black = MoonTime:CreateFrame("Frame","Aussenframe", MoonTime_Layout_noBrain_ConfigPanel, nil, "CENTER", tab, "BOTTOM", 0, 5, 100-4-4,6)
		tab.black:SetBackdrop({bgFile = "Interface/FriendsFrame/UI-Toast-Background", tile=true});
		tab.black:SetBackdropColor(0,0,0, 1)
		tab.black:SetFrameLevel(tab:GetFrameLevel()+2)
		tab.black:Hide()
		
		tab:SetScript("OnMouseUp", function(self) selecttab(name) end )
		
		tabs[name] = tab
	end
	
	
	
	
	
	local infobutton = CreateFrame("Frame","infobutton", MoonTime_Layout_noBrain_ConfigPanel)
	infobutton:SetPoint("BOTTOMRIGHT", aussen, "TOPRIGHT", -5, 3)
	infobutton:SetSize(16,16)
	infobutton.texture = infobutton:CreateTexture("LBPTalent")
	infobutton.texture:SetTexture("Interface/GossipFrame/ActiveQuestIcon")
	infobutton.texture:SetAllPoints()
	
	infobutton:SetScript("OnMouseUp", function(self) if infopanel:IsShown() then infopanel:Hide() else infopanel:Show() end end)
	infobutton:Show();
	
	
	
	
	
	
	
	
	
	
	local infopanel = MoonTime:CreateFrame("Frame", "infopanel", MoonTime_Layout_noBrain_ConfigPanel, nil, "TOPRIGHT", infobutton, "BOTTOMRIGHT", 0, 0, 500, 300)
	infopanel:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",tile = false, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 } });
	
	infopanel:SetFrameLevel(aussen:GetFrameLevel()+10)
	infopanel:Hide()
	
	local infolabel = MoonTime:CreateFontString(infopanel, "infolabel", "ARTWORK","GameFontNormal", "TOPLEFT", infopanel, "TOPLEFT", 10, -10, 400, 300, "LEFT", "TOP", 1, 1, 1, 1)	
	
	infolabel:SetText(L["rotationhelp"])
	
	
	
	
	
	local PADDING = 5
	local height = 280+55+80
	local width = 558		
	
	
	
	
	for k,name in pairs(liste) do
		
		local scrollFrame, editbox = CreateEditBox(self, "MoonTime_Layout_noBrain_ScrollFrame_"..name, MoonTime_Layout_noBrain_ConfigPanel, width, height)
		scrollFrame:SetPoint("TOPLEFT", aussen, "TOPLEFT", 10, -10)
		
		-- scrollFrame:UpdateScrollChildRect()
		scrollFrame:SetVerticalScroll(MoonTime_DB["Layout_noBrain"]["scroll_posi_"..name] or 0)
		scrollFrame:UpdateScrollChildRect()
				
		-- scrollFrame:SetScript("OnUpdate",
		-- function(self)
		-- MoonTime_Layout_noBrain_ScrollFrame:UpdateScrollChildRect()
		-- if MoonTime_Layout_noBrain_ScrollFrame:GetVerticalScrollRange() >= MoonTime_DB["Layout_noBrain"]["default_posi"] then
		-- MoonTime_Layout_noBrain_ScrollFrame:SetVerticalScroll(MoonTime_DB["Layout_noBrain"]["default_posi"]);
		-- MoonTime_Layout_noBrain_ScrollFrame:SetScript("OnUpdate", nil)
		-- end
		-- end
		-- )
		
		
		local replacelist_var = {"SF_name", "W_name", "LunarEmpowered", "SolarEmpowered", "CA_duration", "SunF_CD", "MF_icon", "casttime", "SF_castTime", "W_icon", "charges", "spell", "SS_name", "SS_icon", "SF_icon", "futurePower", "EDir", "chargetime", "SunF_icon", "solarpeak", "lunarpeak", "MF_CD", "dpet_W", "dpet_SF"}
		local replacelist_func = {"isSolar", "isLunar", "GetSetTalentInRow"	}
		editbox.colortext = function(self, text)
			local tmp = text:gsub("|cffcccc00", ""):gsub("|r", ""):gsub("|cff8080ff", "")
			
			for i, replace in pairs(replacelist_func) do
				local blubb = tmp:match(replace.."%(.-%)")
				if blubb then
				blubb = blubb:match("%(.*%)")
				blubb = blubb:sub(2 ,blubb:len()-1)
				
				tmp = tmp:gsub(replace.."%(.-%)", "|cff8080ff"..replace.."(|r" .. blubb .."|cff8080ff)|r")
				end
			end
			
			for i, replace in pairs(replacelist_var) do
				tmp = tmp:gsub(replace, "|cffcccc00"..replace.."|r")
			end
			
			return tmp
		end
		
		editbox.uncolortext = function(self, text)
			return text:gsub("|cffcccc00", ""):gsub("|r", ""):gsub("|cff8080ff", "")
		end
		editbox:SetText(editbox:colortext(MoonTime_DB["Layout_noBrain"][name]))
		
		-- nonchangeable
		if not (name == "custom1" or name =="custom2") then
			-- editbox:SetScript("OnTextChanged", function() editbox:restore() end)
			editbox:SetScript("OnTextChanged", function()
				local position = editbox:GetCursorPosition()-editbox:GetText():len()+editbox:colortext(MoonTime_DB["Layout_noBrain"][name]):len()
				editbox:SetText(editbox:colortext(MoonTime_DB["Layout_noBrain"][name]))
				editbox:SetCursorPosition(position)
			end)
			
			
			
			else
			
			editbox:SetScript("OnTabPressed",
				function(self)
				local text = editbox:GetText()
				local position = editbox:GetCursorPosition()
				
				local newtext = text:sub(1,position) .. "  ".. text:sub(position+1, text:len())
				editbox:SetText(newtext)
				editbox:SetCursorPosition(position+2)
			end
			)
			
			editbox:SetScript("OnTextChanged",
				function (self)
					local position = editbox:GetCursorPosition()
					local text = editbox:GetText()
					local newtext = editbox:colortext(text)
					
					editbox:SetText(newtext)
					if abs(text:len()-newtext:len()) > 2 then
						editbox:SetCursorPosition(position-text:len()+newtext:len())
						else
						
						editbox:SetCursorPosition(position)
					end
				end
			)
		end
		
		editbox:SetScript("OnCursorChanged",
			function(self)
				MoonTime_DB["Layout_noBrain"]["cursor_posi_"..name] = editbox:GetCursorPosition()
			end
		)
		boxes[name] = scrollFrame
		boxes[name].editbox = editbox
		
		scrollFrame:SetScript("OnVerticalScroll",
			function(self)
				MoonTime_DB["Layout_noBrain"]["scroll_posi_"..name] = scrollFrame:GetVerticalScroll()
			end
		)
		
		
		if name == "custom1" or name =="custom2" then
			local restorebutton = CreateFrame("BUTTON", "Button", scrollFrame, "UIPanelButtonTemplate")
			restorebutton:SetText("Restore")
			restorebutton:SetWidth(140)
			restorebutton:SetHeight(25)
			restorebutton:SetScript("OnClick", function(self) 
				editbox:SetText(editbox:colortext(MoonTime_DB["Layout_noBrain"][name]))
			end
			)
			restorebutton:SetPoint('TOPLEFT', scrollFrame, 'BOTTOMLEFT', 0, -10)	
			
			local savebutton = CreateFrame("BUTTON", "Button", scrollFrame, "UIPanelButtonTemplate")
			savebutton:SetText("Save")
			savebutton:SetWidth(140)
			savebutton:SetHeight(25)
			savebutton:SetScript("OnClick", function(self) 
				MoonTime_DB["Layout_noBrain"][name] = editbox:uncolortext(editbox:GetText())
				-- MoonTime_DB["Layout_noBrain"]["rotation"] = name
				MoonTime:setLayout(MoonTime_DB["layout"])	
			end
			)
			savebutton:SetPoint('TOPRIGHT', scrollFrame, 'BOTTOMRIGHT', 20, -10)	
			
			else
			
			local textbox = MoonTime:CreateFontString(scrollFrame, "textbox", "ARTWORK", "GameFontNormal", "TOPLEFT", scrollFrame, "BOTTOMLEFT", 0, -10, 500, 20, "LEFT", "CENTER",  1, 1, 1, 1 );
			textbox:SetText(L["cannotbechanged"])
			textbox:SetTextColor( 1, .5, .5, 1 )
			textbox:Show()
			
		end
		-- restorebutton:Hide()
		
		
	end	
	
	
	
	
	
	MoonTime_Layout_noBrain_ConfigPanel.okay = function()
		if ( MoonTime_Layout_noBrain_ConfigPanel:IsShown() ) then
			
			MoonTime:setLayout(MoonTime_DB["layout"])	
		end	
	end
	
	
	InterfaceOptions_AddCategory(MoonTime_Layout_noBrain_ConfigPanel);
	
	selecttab(MoonTime_DB["Layout_noBrain"]["rotation"])
	MoonTime_Layout_noBrain_ConfigPanel:Hide()
	
	return MoonTime_Layout_noBrain_ConfigPanel
	
	
end


-- ****************************************
--
-- DO NOT CHANGE ANYTHING BELOW THIS 
--
-- ****************************************

local function registerConfig( )									-- Beginn initialize
	local configFrame
	local frame = CreateFrame( "Frame", "frame", UIParent	)
	frame:RegisterEvent("PLAYER_ENTERING_WORLD");
	frame:SetScript("OnEvent", 
		function( self, event )
			frame:UnregisterAllEvents()
			-- if event=="VARIABLES_LOADED" then							-- falls das ausloesende Event VARIABLES_LOADED ist ...
			-- werden die ausstehenden Events registriert
			MoonTimeDoorKeeper:RegisterConfig( self );
			-- end
		end
	)		
	
	
	
	
	frame.createConfig = function( MainConfigFrame )
		configFrame = noBrainBuildConfig( MainConfigFrame )
		
		
		-- InterfaceOptionsFrame_OpenToCategory("MoonTime")
		-- InterfaceOptionsFrame:Hide()
		-- InterfaceOptionsFrame_OpenToCategory("noBrain Rotation Editor")
	end
end																		-- Ende initialize

registerConfig(NameOfLayout)
